<?php


class DispletRetsIdxLoad extends DispletRetsIdxPlugin{
	public function enqueue(){
		self::enqueue_css('displet-rets-idx-styles.css');
		self::enqueue_js('displet-rets-idx-scripts.js', array('jquery', 'jquery-ui-core', 'jquery-ui-widget', 'jquery-ui-datepicker'));
	}

	public function enqueue_admin(){		
		self::enqueue_css('displet-rets-idx-admin-styles.css');
		self::enqueue_js('displet-rets-idx-admin-scripts.js', array('jquery', 'jquery-ui-core', 'jquery-ui-dialog', 'jquery-ui-tabs', 'admin-widgets'));
		self::enqueue_js('displet-rets-idx-photo-upload.js', array('jquery', 'media-upload', 'thickbox'));
		wp_enqueue_style('thickbox');
	}

	public function echo_js_vars_from_options(){
		$model['options'] = DispletRetsIdxSettings::get_option();
		echo self::get_template('displet-javascript-variables.php', $model);
	}

	public function echo_admin_js_vars_from_options(){
		$model['options'] = DispletRetsIdxSettings::get_option();
		echo self::get_template('displet-admin-javascript-variables.php', $model);
	}

	public function enqueue_css($stylesheet) {
		$theme_dir = get_stylesheet_directory();
		$theme_url = get_stylesheet_directory_uri();
		$slug = basename($stylesheet, '.css');
		if (file_exists($theme_dir . '/' . $stylesheet)) {
			wp_enqueue_style($slug, $theme_url . '/' . $stylesheet);
			return;
		}
		wp_enqueue_style($slug, plugins_url('displet-retsidx-beta/css/' . $stylesheet), false, parent::$plugin_version);
	}
	
	public function enqueue_js($script, $dependencies = array()) {
		$theme_dir = get_stylesheet_directory();
		$theme_url = get_stylesheet_directory_uri();
		$slug = basename($script, '.js');
		if (file_exists($theme_dir . '/' . $script)) {
			wp_enqueue_script($slug, $theme_url . '/' . $script, $dependencies);
			return;
		}
		wp_enqueue_script($slug, plugins_url('displet-retsidx-beta/js/' . $script), $dependencies, parent::$plugin_version);
	}

	public function get_template($name, &$model) {
		$theme_dir = get_stylesheet_directory();
		if ($name == 'custom') {
			$names = array('displet-dynamic.php', 'displet-listings.php', 'displet-tile.php');
			foreach ($names as $name) {
				if (file_exists($theme_dir . '/' . $name)) {
					return self::_render($theme_dir . '/' . $name, $model);
				}
			}
		}
		else{
			if (file_exists($theme_dir . '/' . $name)) {
				return self::_render($theme_dir . '/' . $name, $model);
			}
		}
		return self::_render(dirname( __FILE__ ) . '/templates/' . $name, $model);
	}

	public function get_admin_template($name, &$model) {
		return self::_render(dirname( __FILE__ ) . '/templates/admin/' . $name, $model);
	}
	
	public static function draw_admin_template($name, &$model, $model_alias = false) {
		echo self::get_admin_template($name, $model, $model_alias);
	}

	protected static function _render($path, &$model) {
		if (file_exists($path)) {
			ob_start();
			include $path;
			$output = ob_get_contents();
			ob_end_clean();
			return trim($output);
		}
	}
}

add_action('wp_enqueue_scripts', array('DispletRetsIdxLoad', 'enqueue'));
add_action('admin_enqueue_scripts', array('DispletRetsIdxLoad', 'enqueue_admin'));
add_action('wp_head', array('DispletRetsIdxLoad', 'echo_js_vars_from_options'));
add_action('admin_head', array('DispletRetsIdxLoad', 'echo_admin_js_vars_from_options'));

?>